//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/ForceFeedback/BasicImpl/DiscoveryCallbackFactoryImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * RTTC::ForceFeedback::BasicImpl::DiscoveryCallbackFactoryImpl.
 *
 * This file contains the definition of the methods of the
 * RTTC::ForceFeedback::BasicImpl::DiscoveryCallbackFactoryImpl class.
 */

#include "DiscoveryCallbackFactoryImpl.h"

////////////////////////////////////////////////////////////////////////////////
RTTC::ForceFeedback::BasicImpl::
DiscoveryCallbackFactoryImpl::
~DiscoveryCallbackFactoryImpl()
{
  // Basic implementation has no behavior required in callback destructor
}

////////////////////////////////////////////////////////////////////////////////
RTTC::ForceFeedback::BasicImpl::
DiscoveryCallbackFactoryImpl::
DiscoveryCallbackFactoryImpl( CallbackInfoPtr const & pCallbackInfo )
  :
  _pCallbackInfo( pCallbackInfo )
{
  // Generally no behavior in a factory constructor
}

////////////////////////////////////////////////////////////////////////////////
std::auto_ptr< TENA::Middleware::Callback::Callback >
RTTC::ForceFeedback::BasicImpl::
DiscoveryCallbackFactoryImpl::
create( RTTC::ForceFeedback::ProxyPtr const & pProxy )
{
  // For the basic implementation, all the callbacks access a list
  // of SDOs, which is kept updated as SDO's are discovered and destroyed

  return std::auto_ptr< TENA::Middleware::Callback::Callback >(
    new RTTC::ForceFeedback::BasicImpl::DiscoveryCallbackImpl(
      pProxy,
      _pCallbackInfo ) );
}
