/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/SceneGenerator/BasicImpl/PublicationInfoImpl.h
 * \version 5.2.1
 *
 * \brief Contains the declaration of and documentation for
 * RTTC::SceneGenerator::BasicImpl::PublicationInfoImpl.
 *
 * This file contains the declaration of and documentation for the
 * RTTC::SceneGenerator::BasicImpl::PublicationInfoImpl class.
 */

#ifndef RTTC_SceneGenerator_BasicImpl_PublicationInfoImpl_h
#define RTTC_SceneGenerator_BasicImpl_PublicationInfoImpl_h

#include <DCT/System/config.h>
#include <basicImpl_RTTC_TASemulator_v4_EXPORT.h>

#include <RTTC/SceneGenerator/PublicationInfo.h>
#include <RTTC/SceneGenerator/RemoteMethodsFactoryInterface.h>

namespace RTTC
{
  namespace SceneGenerator
  {
    namespace BasicImpl
    {
      /*!\class PublicationInfoImpl PublicationInfoImpl.h \
         RTTC/SceneGenerator/BasicImpl/PublicationInfoImpl.h
       *
       * \brief Holder for all user-defined objects required to create
       * RTTC::SceneGenerator::Servant's.
       *
       * This object contains the following (see PublicationInfo parent class):
       *  - Pointer to RemoteMethodsFactory object.
       *  - Pointer to PublicationInfo object for contained SDO types.
       *
       * The basic implementation for this object should be sufficient for
       * most applications.  However any custom variables needed by the
       * RemoteMethodsFactoryImpl, and/or the MethodsFactoryImpl for any
       * contained local class types must be passed through the constructor
       * of this object to the appropriate contained object.
       */
      class basicImpl_RTTC_TASemulator_v4_EXPORT PublicationInfoImpl
        : public RTTC::SceneGenerator::PublicationInfo
      {
      public:
        //! Use this ctor to create a ServantFactory.
        PublicationInfoImpl();

        virtual
        ~PublicationInfoImpl();

      private:
        //! Default copy construction is disallowed.
        PublicationInfoImpl(
          PublicationInfoImpl const & rhs );
        //! Default copy assignment is disallowed.
        PublicationInfoImpl & operator=(
          PublicationInfoImpl const & rhs );

      };
    } // End of namespace BasicImpl
  } // End of namespace SceneGenerator
} // End of namespace RTTC

#endif // ifndef RTTC_SceneGenerator_BasicImpl_PublicationInfoImpl_h
