//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/TASemulator/BasicImpl/StateChangeCallbackFactoryImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * RTTC::TASemulator::BasicImpl::StateChangeCallbackFactoryImpl.
 *
 * This file contains the definition of the methods of the
 * RTTC::TASemulator::BasicImpl::StateChangeCallbackFactoryImpl class.
 */

#include "StateChangeCallbackFactoryImpl.h"
#include <RTTC/TASemulator/Proxy.h>

////////////////////////////////////////////////////////////////////////////////
RTTC::TASemulator::BasicImpl::
StateChangeCallbackFactoryImpl::
~StateChangeCallbackFactoryImpl()
{
  // Basic implementation has no behavior required in callback destructor
}

////////////////////////////////////////////////////////////////////////////////
RTTC::TASemulator::BasicImpl::
StateChangeCallbackFactoryImpl::
StateChangeCallbackFactoryImpl( CallbackInfoPtr const & pCallbackInfo)
  :
  _pCallbackInfo( pCallbackInfo )
{
  // Generally no behavior in a factory constructor
}

////////////////////////////////////////////////////////////////////////////////
std::auto_ptr< TENA::Middleware::Callback::Callback >
RTTC::TASemulator::BasicImpl::
StateChangeCallbackFactoryImpl::
create( RTTC::TASemulator::ProxyPtr const & pProxy )
{
  // For the basic implementation, stateChange just uses the ProxyPtr to report state change
  // info using the output stream in the CallbackInfo

  return std::auto_ptr< TENA::Middleware::Callback::Callback >(
    new RTTC::TASemulator::BasicImpl::StateChangeCallbackImpl(
      pProxy,
      _pCallbackInfo ) );
}
