// SceneGeneratorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SceneGenerator.h"
#include "SceneGeneratorDlg.h"
#include ".\scenegeneratordlg.h"


#define R2D 57.2957795


#include <TENA/Middleware/Config.h>
//#include <TASEmulatorPublisherSingleton.h>
//#include <SceneGeneratorPublisherSingleton.h>
#include <ace/os.h>
#include "ace/ace.h"

#include "aceosgthread.h"
#include "TENASubscriber.h"



// globals used to pass to MFC Text (or Edit Control) boxes
extern double gMFCfieldOfView;
extern double gMFCzoomFactor;
extern int    gMFCterrainID;
extern double gMFCviewFromX;
extern double gMFCviewFromY;
extern double gMFCviewFromZ;
extern double gMFCviewToX;
extern double gMFCviewToY;
extern double gMFCviewToZ;
extern double gMFCviewPsi;
extern double gMFCviewTheta;
extern double gMFCviewPhi;

extern int globalOSGHFOVValue;
extern int globalOSGVFOVValue;

//extern double gMFCviewRotationAngle;
extern bool   gNoPlace;
bool bResignOSG = false;
bool bResignTENA = false;

// GUI Status Bar indicators
static UINT BASED_CODE indicators[] =
{
	IDC_INDICATOR_POS,
	IDC_INDICATOR_TIME
};


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//  Threading stuff
//extern int StartOSGThread(void);

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSceneGeneratorDlg dialog



CSceneGeneratorDlg::CSceneGeneratorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSceneGeneratorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSceneGeneratorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_VIEWFROMX, _sViewFromX);
	DDX_Text(pDX, IDC_VIEWFROMY, _sViewFromY);
	DDX_Text(pDX, IDC_VIEWFROMZ, _sViewFromZ);
	//DDX_Text(pDX, IDC_FIELDOFVIEW, _sFieldOfView);
	//DDX_Text(pDX, IDC_ZOOMFACTOR, _sZoomFactor);
	//DDX_Text(pDX, IDC_TERRAINID, _sTerrainID);
	DDX_Text(pDX, IDC_VIEWTOX, _sViewToX);
	DDX_Text(pDX, IDC_VIEWTOY, _sViewToY);
	//DDX_Text(pDX, IDC_VIEWTOZ, _sViewToZ);
	DDX_Text(pDX, IDC_VIEWROTANGLE, _sViewRotationAngle);

	DDX_Control(pDX, IDC_VIEWFROMX, _cntlViewFromX);
	DDX_Control(pDX, IDC_VIEWFROMY, _cntlViewFromY);
	DDX_Control(pDX, IDC_VIEWFROMZ, _cntlViewFromZ);
	//DDX_Control(pDX, IDC_FIELDOFVIEW, _cntlFieldOfView);
	//DDX_Control(pDX, IDC_ZOOMFACTOR, _cntlZoomFactor);
	//DDX_Control(pDX, IDC_TERRAINID, _cntlTerrainID);
	DDX_Control(pDX, IDC_VIEWTOX, _cntlViewToX);
	DDX_Control(pDX, IDC_VIEWTOY, _cntlViewToY);
	//DDX_Control(pDX, IDC_VIEWTOZ, _cntlViewToZ);
	DDX_Control(pDX, IDC_VIEWROTANGLE, _cntlViewRotationAngle);
	
}

BEGIN_MESSAGE_MAP(CSceneGeneratorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTONSG, OnBnClickedButtonsg)
	ON_BN_CLICKED(IDC_BUTTONJOINTENA, OnBnClickedButtonjointena)
	ON_BN_CLICKED(IDC_BUTTONRESIGNTENA, OnBnClickedButtonresigntena)
	ON_WM_TIMER()
	
	
	ON_BN_CLICKED(IDOK, &CSceneGeneratorDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CSceneGeneratorDlg message handlers

BOOL CSceneGeneratorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	_nTimer = SetTimer(1, 100, NULL);

	// Status bar initialization
	m_bar.Create(this);
	m_bar.SetIndicators(indicators,2);
	CRect rect;
	GetClientRect(&rect);
	m_bar.SetPaneInfo(0,IDC_INDICATOR_POS,SBPS_NORMAL,rect.Width()-125);
	m_bar.SetPaneInfo(1,IDC_INDICATOR_TIME,SBPS_STRETCH,0);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, IDC_INDICATOR_TIME);
	m_bar.GetStatusBarCtrl().SetBkColor(RGB(180,180,100));

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSceneGeneratorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSceneGeneratorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSceneGeneratorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
void CSceneGeneratorDlg::OnTimer(UINT nIDEvent)
{
	
	_sZoomFactor.Format("%f", gMFCzoomFactor);
	_sTerrainID.Format("%f", gMFCterrainID);
	_sViewFromX.Format("%f", gMFCviewFromX);
	_sViewFromY.Format("%f", gMFCviewFromY);
	_sViewFromZ.Format("%f", gMFCviewFromZ);
	_sViewToX.Format("%f", gMFCviewTheta*R2D);//("%f", gMFCviewToX*R2D);
	_sViewToY.Format("%f", gMFCviewPhi*R2D);//("%f", gMFCviewToY*R2D);
	_sViewToZ.Format("%f", gMFCviewToZ);
	_sViewRotationAngle.Format("%f", gMFCviewPsi*R2D);//("%f", gMFCviewRotationAngle*R2D);

	
	_cntlViewFromX.SetWindowText(_sViewFromX);
	_cntlViewFromY.SetWindowText(_sViewFromY);
	_cntlViewFromZ.SetWindowText(_sViewFromZ);
	_cntlViewToX.SetWindowText(_sViewToX);
	_cntlViewToY.SetWindowText(_sViewToY);
	//_cntlViewToZ.SetWindowText(_sViewToZ);
	_cntlViewRotationAngle.SetWindowText(_sViewRotationAngle);

/*	if (gNoPlace) {
		gNoPlace = false;
		GetDlgItem(IDC_INFO)->SetWindowText("Bad Terrain Isect!");
	}
	else
		GetDlgItem(IDC_INFO)->SetWindowText("Good!");*/


	CDialog::OnTimer(nIDEvent);

}
void CSceneGeneratorDlg::OnBnClickedButtonsg()
{
	//int retval = StartOSGThread();
	thread_data myArgs;
    ACE::init();
	ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
	
	tm->spawn(ACE_THR_FUNC(StartOSGThread), (void *) &myArgs);
	
	ACE_OS::sleep(ACE_Time_Value(5,0));
}

void CSceneGeneratorDlg::OnBnClickedButtonjointena()
{
	CString sTENAInfo;

	// spawn TENA publsher thread
    thread_data myArgsSub;
  
	ACE_Thread_Manager *tmSub = ACE_Thread_Manager::instance();
	
	tmSub->spawn(ACE_THR_FUNC(TENASubscriber), (void *) &myArgsSub);
	ACE_OS::sleep(ACE_Time_Value(1,0));


	sTENAInfo.Format("Joined TENA");
	UpdateData();
	m_bar.SetPaneText(0,sTENAInfo);
	//m_bar.SetPaneText(1,sTriple_Ori);
	UpdateData(false);
}

void CSceneGeneratorDlg::OnBnClickedButtonresigntena()
{
	CString sTENAInfo;

/*	if(SCENE_GENERATOR_PUBLISHER->ResignTENA())
	{
			//GetDlgItem(IDC_INFO)->SetWindowText("Resigned TENA");
			sTENAInfo.Format("Resigned TENA");
			UpdateData();
			m_bar.SetPaneText(0,sTENAInfo);
			//m_bar.SetPaneText(1,sTriple_Ori);
			UpdateData(false);
	}*/
}



void CSceneGeneratorDlg::OnBnClickedOk()
{
	bResignOSG = true;
	bResignTENA = true;
	Sleep(2000);
	OnOK();
}
