/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/PlatformExtension/BasicImpl/SubscriberImpl.h
 * \version 5.2.1
 *
 * \brief Contains all the \#include files for subscribing to
 * TENA::PlatformExtension SDOs.
 *
 * This header file aggregates numerous other header files needed by virtually
 * any TENA Middleware application that subscribes to
 * TENA::PlatformExtension SDOs.
 *
 * It is the one header file that all TENA Middleware application programs
 * should \#include in order to subscribe to
 * TENA::PlatformExtension SDOs.
 */

#ifndef TENA_PlatformExtension_BasicImpl_SubscriberImpl_h
#define TENA_PlatformExtension_BasicImpl_SubscriberImpl_h

#include <TENA/PlatformExtension/Subscriber.h>
#include <basicImpl_TENA_Platform_v3_1_mscRegisterFactory.h>
#include "CallbackInfo.h"
#include "DestructionCallbackFactoryImpl.h"
#include "DestructionCallbackImpl.h"
#include "DiscoveryCallbackFactoryImpl.h"
#include "DiscoveryCallbackImpl.h"
#include "StateChangeCallbackFactoryImpl.h"
#include "StateChangeCallbackImpl.h"
#include "SubscriptionInfoImpl.h"

#endif // ifndef TENA_PlatformExtension_BasicImpl_SubscriberImpl_h
