#include "stdafx.h"
#include <process.h>
#include <ace/OS.h>

//  Global variables used to pass data to OSG Thread

// globals used to pass to MFC Text (or Edit Control) boxes
extern double gMFCfieldOfView;
extern double gMFCzoomFactor;
extern int    gMFCterrainID;
extern double gMFCviewFromX;
extern double gMFCviewFromY;
extern double gMFCviewFromZ;
extern double gMFCviewToX;
extern double gMFCviewToY;
extern double gMFCviewToZ;
extern double gMFCviewPsi;
extern double gMFCviewTheta;
extern double gMFCviewPhi;


long timeStamp;

extern int globalOSGPanValue; //this is the value from the Pan slider
extern int globalOSGTiltValue; //this is the value from the Tilt slider

extern double gMFCpsi;
extern double gMFCtheta;
extern double gMFCphi;

extern bool bResignTENA;

/////////////////////////////////////////////////////


#include "TENASubscriber.h"

#include <TENA/Middleware/config.h>


// *implementation* needed to create and access the local class
#include <TENA/UniqueID/Includes.h>
#include <TENA/Time/Includes.h>
#include <TENA/CoordinatedUniversalTime/Includes.h>
#include <TENA/Date/Includes.h>
#include <TENA/GpsTime/Includes.h>
#include <TENA/UnixTime/Includes.h>
#include <TENA/PlatformType/Includes.h>
#include <DIS/EntityType/Includes.h>
#include <TENA/TSPI/Includes.h>
#include <TENA/AngularAcceleration/Includes.h>
#include <TENA/AngularVelocity/Includes.h>
#include <TENA/GeocentricAcceleration/Includes.h>
#include <TENA/GeocentricSpatialReferenceFrame/Includes.h>
#include <TENA/SpatialReferenceFrame/Includes.h>
#include <TENA/GeocentricOrientationEuler/Includes.h>
#include <TENA/GeocentricPosition/Includes.h>
#include <TENA/GeocentricVelocity/Includes.h>
#include <TENA/GeodeticAcceleration/Includes.h>
#include <TENA/GeodeticSpatialReferenceFrame/Includes.h>
#include <TENA/GeodeticOrientationEuler/Includes.h>
#include <TENA/GeodeticPosition/Includes.h>
#include <TENA/GeodeticVelocity/Includes.h>
#include <TENA/LocalSphericalTangentPlaneAcceleration/Includes.h>
#include <TENA/LocalSphericalTangentPlaneSpatialReferenceFrame/Includes.h>
#include <TENA/LocalSphericalTangentPlaneOrientationEuler/Includes.h>
#include <TENA/LocalSphericalTangentPlanePosition/Includes.h>
#include <TENA/LocalSphericalTangentPlaneVelocity/Includes.h>
#include <TENA/LocalTangentPlaneENUacceleration/Includes.h>
#include <TENA/LocalTangentPlaneENUspatialReferenceFrame/Includes.h>
#include <TENA/LocalTangentPlaneENUorientationEuler/Includes.h>
#include <TENA/LocalTangentPlaneENUposition/Includes.h>
#include <TENA/LocalTangentPlaneENUvelocity/Includes.h>
#include <TENA/Acceleration/Includes.h>
#include <TENA/Orientation/Includes.h>
#include <TENA/Position/Includes.h>
#include <TENA/Velocity/Includes.h>

#include <RTTC/TASemulator/BasicImpl/SubscriberImpl.h>



#include "Configuration.h"

#define   R2D	57.2957795
#define   D2R   0.0174532925
char ts[] = "                                                      ";



void* TENASubscriber( void *pArgs )
{

	//MessageBox(NULL,"From Tena Subscriber","",MB_OK);

	// TENA pointers
	TENA::Middleware::RuntimePtr pTENAmiddlewareRuntime_;
	TENA::Middleware::ExecutionPtr pExecution_;
	TENA::Middleware::SessionPtr pSession_;

	TENA::LocalTangentPlaneENUspatialReferenceFrame::Pointer pLTPSRF_;
	short verbosity = 3;   // default TENA output verbosity val

//	RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::MessageSenderPtr pMessageSender;

	ConfigurationFile config_;  //configuration file values
	long millisecondsBetweenUpdates(100);

	try
	{
		config_.SetConfigurationFileName("config.txt"); // read configuration file
		config_.ReadFile();

		std::string sExecutionName = config_.GetExecutionName();  // retrieve config params
		std::string sSessionName = config_.GetSessionName();
		std::string sInitRef = config_.GetORBdefaultInitRef();

		int argc = 6;
		char * argv[] = {"-ORBdefaultInitRef", (char *) sInitRef.c_str(), "-executionName", (char *) sExecutionName.c_str(), "-sessionName", (char *) sSessionName.c_str(), NULL};

		TENA::Middleware::Configuration tenaMiddlewareConfiguration (
			argc,
			argv );

		pTENAmiddlewareRuntime_ = TENA::Middleware::RuntimePtr (
			TENA::Middleware::init( tenaMiddlewareConfiguration ) );

		pExecution_ = TENA::Middleware::ExecutionPtr (
			pTENAmiddlewareRuntime_->joinExecution( sExecutionName ) );

		pSession_ = TENA::Middleware::SessionPtr (
			pExecution_->createSession( sSessionName ) );

		}
	    catch(...) {
		    MessageBox(NULL,"Unable to join TENA Execution","Error!",MB_OK);
		    return 0;
	    }

		RTTC::TASemulator::BasicImpl::CallbackInfoPtr  pCallbackInfo(
        new RTTC::TASemulator::BasicImpl::CallbackInfo( std::cout, verbosity ) );

    // Create a SubscriptionInfo, which holds callback factories and
    // can pass custom application data (pCallbackInfo, in this case)
    // via those factories to the callbacks.  In most circumstances,
    // the auto-generated basic implementation version is sufficient.
    RTTC::TASemulator::SubscriptionInfoPtr pSubscriptionInfo(
      new RTTC::TASemulator::BasicImpl::SubscriptionInfoImpl(
        pCallbackInfo ) );

    // Declare the application's interest in Platform objects.
    pSession_->subscribeToSDO< RTTC::TASemulator::ProxyTraits >(
      pSubscriptionInfo );


    // This subscriber application will run until SDOs are discovered, and will
    // exit after iterationsOfDelayBeforeExit when all discovered SDOs are
    // destroyed.
    bool anSDOhasBeenDiscovered( false );
	long iterationsOfDelayBeforeExit(2500);
    long delay( iterationsOfDelayBeforeExit );

	unsigned long millisecondsPerCallbackIteration( 100 );

	int counter = 0;

	// set up for TASemulator publishing
	// Create a PublicationInfoImpl helper object that can be used to provide
    // the RemoteMethodsImpl access to application variables/objects.  See the
    // RTTC::TASemulator::BasicImpl::PublicationInfoImpl header file for
    // usage information.
/*    RTTC::TASemulator::PublicationInfoPtr pPublicationInfo(
      new RTTC::TASemulator::BasicImpl::PublicationInfoImpl );

    // Create a ServantFactory to create TASemulator objects.
    RTTC::TASemulator::ServantFactoryPtr pServantFactory(
      pSession_->
        createServantFactory< RTTC::TASemulator::ServantTraits >(
          pPublicationInfo ) );

	TENA::Middleware::CommunicationProperties communicationProperties = TENA::Middleware::Reliable;
    

	// Create a TASemulator Servant that is returned as a smart pointer
    RTTC::TASemulator::ServantPtr pTASemulatorServant(
      pServantFactory->createServantUsingDefaultFactory(
        communicationProperties ) );*/

	
    do
    {
      unsigned long const callbackIntervalInUsec(
        ( unsigned long )( millisecondsPerCallbackIteration ) * 100 );  //* 1000 );

      // Callbacks are only processed during evoke methods, as shown here.
      pSession_->evokeMultipleCallbacks( callbackIntervalInUsec );

      if ( 0 < pCallbackInfo->getDiscoveredSDOlist().size() )
      {
		  int mysize = pCallbackInfo->getDiscoveredSDOlist().size();
		  std::cout << "Number of TAS = " << mysize << std::endl;
          delay = iterationsOfDelayBeforeExit;
          anSDOhasBeenDiscovered = true;

		  counter = 1;

		  for ( std::list < RTTC::TASemulator::ProxyPtr >::iterator i = 
                pCallbackInfo->getDiscoveredSDOlist().begin();
                i != pCallbackInfo->getDiscoveredSDOlist().end();
                ++i )
			{
				std::cout << "Stuff for TAS # " << counter << std::endl;
				counter++;
				RTTC::TASemulator::ProxyPtr pTASemulatorProxy( (*i) );

				RTTC::TASemulator::ImmutablePublicationStatePtr pubState = 
					pTASemulatorProxy->getPublicationState();

				gMFCfieldOfView = pubState->get_fieldOfView();
				gMFCzoomFactor = pubState->get_zoomFactor();
				gMFCterrainID = pubState->get_terrainID();
				gMFCviewFromX = pubState->get_viewFromX();
				gMFCviewFromY = pubState->get_viewFromY();
				gMFCviewFromZ = pubState->get_viewFromZ();
				gMFCviewToX = pubState->get_viewToX();
				gMFCviewToY = pubState->get_viewToY();
				gMFCviewToZ = pubState->get_viewToZ();

				gMFCviewPsi = pubState->get_viewPsi();
				gMFCviewTheta = pubState->get_viewTheta();
				gMFCviewPhi = pubState->get_viewPhi();
				

				 // Set Global Vars for OSG viewer thread
				
			}
      }
      else if ( anSDOhasBeenDiscovered )
      {
          --delay;
      }
    }
    while ( !bResignTENA );


	return 0;
}


